; ====================================================;
;                                                     ;
;      gpedit.inc for EC v2 Fasm visual projects      ;
;                   (version 1.0.1)                   ;
;                                                     ;
;            Copyright  Ramon Sala - 2022            ;
;                                                     ;
; ====================================================;

if ~defined GPEDIT_INC
define GPEDIT_INC 1

struct GPOBROWSEINFO
    dwSize       dd   ?
    dwFlags      dd   ?
    hwndOwner    xptr ?
    lpTitle      xptr ?
    lpInitialOU  xptr ?
    lpDSPath     xptr ?
    dwDSPathSize dd   ?
    lpName       xptr ?
    dwNameSize   dd   ?
    gpoType      xptr ?
    gpoHint      xptr ?
ends

if defined APP_WIN64
    extrn '__imp_BrowseForGPO' as BrowseForGPO:qword
    extrn '__imp_CreateGPOLink' as CreateGPOLink:qword
    extrn '__imp_DeleteAllGPOLinks' as DeleteAllGPOLinks:qword
    extrn '__imp_DeleteGPOLink' as DeleteGPOLink:qword
    extrn '__imp_ExportRSoPData' as ExportRSoPData:qword
    extrn '__imp_ImportRSoPData' as ImportRSoPData:qword
else
    extrn '__imp__BrowseForGPO@4' as BrowseForGPO:dword
    extrn '__imp__CreateGPOLink@12' as CreateGPOLink:dword
    extrn '__imp__DeleteAllGPOLinks@4' as DeleteAllGPOLinks:dword
    extrn '__imp__DeleteGPOLink@8' as DeleteGPOLink:dword
    extrn '__imp__ExportRSoPData@8' as ExportRSoPData:dword
    extrn '__imp__ImportRSoPData@8' as ImportRSoPData:dword
end if

end if ;GPEDIT_INC
